const m = require('mithril');
const solid = require("../dist/solid");
const regular = require("../dist/regular");
const brands = require("../dist/brands");
const randomColor = () => `#${Math.random().toString(16).slice(2,8)}`;
const makeIcon = ic => Object.keys(ic).map(i => {
  return m(".col.col-3.p-2.text-center", { key: i }, m(`a.card.p-centered.p-2.tooltip[data-tooltip=${i}]`, m(ic[i], {
    svgAttrs: {
      width: "32px",
      height: "32px",
      fill: randomColor()
    }
  })));
});

const IconList = {
  view({ attrs, state }) {
    return;
  }
}

const IconPages = {
  tab: {
    current: 0,
    list: [
      makeIcon(solid),
      makeIcon(regular),
      makeIcon(brands)
    ],
    s: s => t => e => {
      if (s.tab.list[t]) {
        s.tab.current = t;
      } else {
        s.tab.current = 0;
      }
    }
  },
  view({ state }) {
    
    /* state.tab */
    const tabActive = t => t === state.tab.current ? ".active" : "";
    const tabSwitch = state.tab.s(state);
    const tabCurrent = state.tab.list[state.tab.current];
    const tabCount = t => Object.keys(t).length;
    
    return [
      m("h3.text-center", "Icon List"),
      m(".divider"),
      m("ul.tab.tab-block", [
        m("li.tab-item"+tabActive(0), m(`a.badge[data-badge=${tabCount(solid)}]`, {
          onclick: tabSwitch(0)
        }, "Solid")),
        m("li.tab-item"+tabActive(1), m(`a.badge[data-badge=${tabCount(regular)}]`, {
          onclick: tabSwitch(1)
        }, "Regular")),
        m("li.tab-item"+tabActive(2), m(`a.badge[data-badge=${tabCount(brands)}]`, {
          onclick: tabSwitch(2)
        }, "Brands")),
      ]),
      m(".container", m(".columns", tabCurrent)),
      
    ]
  }
}

m.mount(document.body, IconPages);